AR_DIR=lib
LIB_DIR=..\$(AR_DIR)
DLL_DIR=.\$(AR_DIR)
BUILD_SETVALUE=DEBUG


TARGETS=\
 oxflibs\
 omcomlib\
 tomlib\
 aomlibs\
 oxfdll\
 oxfanimdll\
 oxftracedll\
 webcomponentslib\
 simlib\
 simulinkintegrationlib

DEL_CMD=del
!IF "$(OS)" == "Windows_NT"
NULL=
DEL_CMD=del /q
!ELSE
NULL=nul
!ENDIF

BUILD_TARGET=
STL_SUFFIX=

!IF "$(BUILD_SET)" == "Release"
BUILD_SETVALUE=RELEASE
!ELSE
!IF "$(BUILD_SET)" != "Debug"
!MESSAGE An invalid BUILD_SET "$(BUILD_SET)" is specified.
!MESSAGE BUILD_SET=Debug or BUILD_SET=Release should be set
!MESSAGE BUILD_SET=Debug is set
!ENDIF
!ENDIF

!IF "$(USE_STL)" == "TRUE"
STL_SUFFIX=Stl
!ENDIF

CRT_FLAGS=/D "_CRT_SECURE_NO_DEPRECATE"
ENABLE_EH=/EHa
LIB_PREFIX=MS$(MS_VER)$(STL_SUFFIX)
!IF "$(MS_VER)" != "2005"
!IF "$(MS_VER)" != "2009"
!IF "$(MS_VER)" != "VC9"
!IF "$(MS_VER)" != "2010"
!IF "$(MS_VER)" != "VC10"
CRT_FLAGS=
ENABLE_EH=/GX
LIB_PREFIX=MS$(STL_SUFFIX)
!ENDIF
!ENDIF
!ENDIF
!ENDIF
!ENDIF



MAKE=nmake /S /NOLOGO BUILD_SET="$(BUILD_SETVALUE)" USE_STL="$(USE_STL)" USE_PDB="$(USE_PDB)" LIB_DIR="$(LIB_DIR)" CRT_FLAGS="$(CRT_FLAGS)" ENABLE_EH="$(ENABLE_EH)" LIB_PREFIX="$(LIB_PREFIX)"
all : $(TARGETS)

oxflibs :
	cd oxf
	$(MAKE) -f msoxf.mak CFG="oxf" $(BUILD_TARGET)
	$(MAKE) -f msoxf.mak CFG="oxfinst" $(BUILD_TARGET)
	cd ..
simlib :
	cd simulation
	$(MAKE) -f mssim.mak CFG="sim" $(BUILD_TARGET)
	cd ..

omcomlib:
	cd omcom
	$(MAKE) -f msomcom.mak CFG="omcomappl" $(BUILD_TARGET)
	cd ..

## tomtraceRiC create a bridge library to attach C code to the C++ TOM ##
tomlib:
	cd tom
	$(MAKE) -f mstom.mak CFG="tomtrace" $(BUILD_TARGET)
	$(MAKE) -f mstom.mak CFG="tomtraceRiC" $(BUILD_TARGET)
	cd ..

aomlibs:
	cd aom
	$(MAKE) -f msaom.mak CFG="aomtrace" $(BUILD_TARGET)
	$(MAKE) -f msaom.mak CFG="aomanim" $(BUILD_TARGET)
	cd ..

oxfdll:
	$(MAKE) -f msoxfanimtracedll.mak CFG="oxfdll" $(BUILD_TARGET) DLL_DIR=$(DLL_DIR)

oxfanimdll:
	$(MAKE) -f msoxfanimtracedll.mak CFG="oxfanimdll" $(BUILD_TARGET) DLL_DIR=$(DLL_DIR)

oxftracedll:
	$(MAKE) -f msoxfanimtracedll.mak CFG="oxftracedll" $(BUILD_TARGET) DLL_DIR=$(DLL_DIR)

webcomponentslib:
	cd WebComponents
	$(MAKE) -f msWebComponents.mak CFG="WebComponents" $(BUILD_TARGET)
	cd ..
	
simulinkintegrationlib:
	cd SimulinkIntegration
	$(MAKE) -f msSimulinkIntegration.mak CFG="SimulinkIntegration" $(BUILD_TARGET)
	cd ..
